#!/bin/bash

SENDERLIST="/etc/raspiradio/raspiradio.lst"
ICECREAM="/usr/local/bin/icecream"
#MPEGPLAYER="/usr/bin/mpg123"
MPEGPLAYER="/usr/bin/mplayer -lircconf /etc/raspiradio/raspiradio.lircrc -quiet"
CURRSENDERFILE=/var/tmp/radiocurrentsender

if [ X$1 == X ]; then
	echo "we need a sendernumber or a command (start/stop/UP/DOWN) as argument"
	exit -1
fi

if [ X$1 == Xstop ]; then
	pkill -f $ICECREAM
	exit 0
fi	

declare -a SENDERS
SENDERS=($(cat "$SENDERLIST" | tr '\n' ' '))
SENDERCOUNT=${#SENDERS[*]}

if [ $SENDERCOUNT -eq 0 ]; then
	echo "No senders in list file $SENDERLIST. Cannot start program."
	exit -1
fi

SELECTEDSENDER=$1

if [ X$SELECTEDSENDER == Xstart ];then
	if [ -f $CURRSENDERFILE ]; then
		SELECTEDSENDER=`cat $CURRSENDERFILE`
	else
		SELECTEDSENDER=1
	fi
fi

if [ ! X$SELECTEDSENDER == XUP ]; then
	if [ ! X$SELECTEDSENDER == XDOWN ]; then
		CURRSENDER=$SELECTEDSENDER
	else
		CURRSENDER=`cat $CURRSENDERFILE`
		CURRSENDER=$((CURRSENDER-1))
		if [ $CURRSENDER -eq 0 ]; then
			CURRSENDER=$SENDERCOUNT
		fi
	fi
else
	CURRSENDER=`cat $CURRSENDERFILE`
	CURRSENDER=$((CURRSENDER+1))
	if [ $CURRSENDER -gt $SENDERCOUNT ]; then
		CURRSENDER=1
	fi
fi

if [ $CURRSENDER -le 0 ] || [ $CURRSENDER -gt $SENDERCOUNT ]; then
	echo "This sender number ($1) is not valid. Check contents of sender list file $SENDERLIST. Now choosing first sender of list"
	CURRSENDER=1
fi

echo $CURRSENDER > $CURRSENDERFILE

ICECOUNT=`pgrep -c -f $ICECREAM`
while [ X$ICECOUNT != X0 ]; do
	pkill -f $ICECREAM
	sleep 1
	ICECOUNT=`pgrep -c -f $ICECREAM`
done

SENDERID=$(($CURRSENDER-1))
$ICECREAM --stdout  ${SENDERS[$SENDERID]} | $MPEGPLAYER - &
exit 0

